<template>
  <div
    class="min-h-full flex flex-col items-center justify-center py-12 px-4 sm:px-6 lg:px-8"
  >
    <div v-if="roadtrip.stepsCityTour.length > 0" class="max-w-7xl w-full bg-white p-4 md:px-8 shadow-xl">
      <Vuemik
        class="space-y-6"
        :initial-values="roadtrip.generateStepCityTourInitialValues()"
        :on-submit="roadtrip.submitStepCityTour"
        v-slot="{ values, handleSubmit }"
      >
        <fieldset>
          <div class="mb-5 md:flex md:flex-row md:justify-center relative text-center">
            <div class="md:absolute left-0">
              <Button
                @click="roadtrip.reSubmitRoadtrip()"
                label="Recalculer ce roadtrip"
              />
            </div>

            <div class="w-full my-3 md:my-0">
              <h2 class="text-3xl font-extrabold text-gray-900">
                Etapes City Tour
              </h2>
            </div>
          </div>

          <div :key="index" v-for="(step, index) in roadtrip.stepsCityTour">
            <h3 class="mt-6 text-center text-2xl font-extrabold text-gray-900">
              {{ step.nbDay ? "Jour " + step.nbDay : "Tout les jours" }}
            </h3>
            <div v-if="step.restaurants !== undefined">
              <h4 class="text-yellow-600 font-bold">Restaurants :</h4>
              <div class="lg:flex lg:items-stretch gap-8">
                <div
                  class="w-full lg:w-1/3"
                  v-for="restaurant in step.restaurants"
                  :key="restaurant.id"
                >
                  <RadioField
                    :name="getRestaurantKey(step)"
                    :value="restaurant.id"
                    :label="restaurant.name"
                    :description="restaurant.tags.map(tag => translation.displayTagOrCategory(tag, 'tag')).join(', ')"
                    :checked="restaurant.id === values[getRestaurantKey(step)]"
                    @input="values[getRestaurantKey(step)] = $event.target.value"
                  />
                </div>
              </div>
              <h5 v-if="step.restaurants.length === 0">
                Aucun restaurant trouvé
              </h5>
            </div>
            <div v-if="step.hostels !== undefined">
              <h4 class="text-yellow-600 font-bold">Hôtels :</h4>
              <div class="lg:flex lg:items-stretch gap-8">
                <div
                  class="w-full lg:w-1/3"
                  v-for="hostel in step.hostels"
                  :key="hostel.id"
                >
                  <RadioField
                    :name="getRestaurantKey(step)"
                    :value="hostel.id"
                    :label="hostel.name"
                    :description="hostel.categorySet.map(categoryId => translation.displayTagOrCategory(categoryId, 'category')).join(', ')"
                    :checked="hostel.id === values[getHostelKey(step)]"
                    @input="values[getHostelKey(step)] = $event.target.value"
                  />
                </div>
              </div>
              <h5 v-show="step.hostels.length === 0">Aucun hôtel trouvé</h5>
            </div>
          </div>
          <div class="mt-5">
            <button
                class="py-2 px-4 text-sm font-medium rounded-md w-full text-white bg-yellow-500 hover:bg-yellow-600"
                @click.prevent="handleSubmit"
            >
              Valider
            </button>
          </div>
        </fieldset>
      </Vuemik>
      <p class="text-center">
        Un choix automatique sera fait pour vous si vous ne choisissez pas
        d'hôtel ou de restaurant.
      </p>
    </div>
  </div>
</template>

<script>
import RadioField from "@/components/Form/RadioField.vue";
import Button from "@/components/Button";

export default {
  name: "CityTourStepForm",
  inject: ["roadtrip","translation"],
  components: {
    RadioField,
    Button
  },
  methods: {
    getHostelKey: step => 'hostel_'+(step.nbDay??'all'),
    getRestaurantKey: step => 'restaurant_'+(step.nbDay??'all')
  },
  beforeMount() {
    if (this.roadtrip.stepsCityTour === null) {
      this.$router.push("/");
    }
  },
};
</script>
